module(..., package.seeall)

utilities = require("utilities")
dialog = require("dialog_utilities")
d = require("dialog")
onto = require("get_onto")
spy = require("Endpoint.Spy_Endpoint")
recalc = require("Association_recalc")

local report = require("reporter.report")
local namedGraphName = ""

--form parameters
formID = "LoadOntology"
formCaption = "Load Ontology"

--checks if this is first open and shows form to load ontology
function open()
	report.event("ViziQuer_ProjectOpen")
	--initialize parameters
	--initParam()
	--check if this is first open (as create project)
--	if utilities.get_tags(lQuery("Project"), "IsFirst"):is_empty() then
		print ("open!!!")
		form()
		--print("form")
--		endpointForm()
		--set that project info is set
--		utilities.add_tag(lQuery("Project"), "IsFirst", "true", true)
--	end
end

--create the basic form to load ontology
function form()
	formAttributes =
		{caption = formCaption,
		id = formID,
		--will call event Close when X clicked at the top of the form
		buttonClickOnClose = false,
		--add that elements will be righ aligned
		--horizontalAlignment = 1,
		minimumWidth = 300,
		minimumHeight = 200
		}

	--Use utilities library to add and display form also auto delete form at end
	form = dialog.add_form (formAttributes)
		--add event handler that will close form when X clicked at the form top
		dialog.add_event_handlers(form, {Close = "lua.openProject.close"})
	--add buttons for ontology from file or ontology from endpoint
	local fileButton = d.add_component("D#Button", 	{caption = "Load from file", minimumWidth = 200, minimumHeight = 75} , form)
	dialog.add_event_handlers(fileButton, {Click = "lua.loadOntology.select_and_load_ontology"})
	local endpointButton = d.add_component("D#Button", 	{caption = "Load from SPARQL endpoint", minimumWidth = 200, minimumHeight = 75} , form)
	dialog.add_event_handlers(endpointButton, {Click = "lua.openProject.enterEndpoint"})
	print (formID)
	--show the form
	dialog.show_form(form)
end

--form to input SPARQL endpoint
function endpointForm()
	print ("clear")
	--if it is change button then we need to clear the form
	clearForm()
	--add all new elements to form
	local form = lQuery("D#Form[id='".. formID .. "']")
	local vBox = d.add_component("D#VerticalBox", 	{horizontalAlignment = -1, verticalAlignment = 0} , form)
	local label = d.add_component("D#Label", 	{caption = "Input SPARQL endpoint adress:"} , vBox)
	-- http://data.semanticweb.org/sparql
	--local input = d.add_component("D#InputField", 	{id = "EndpointInput", text = "http://194.8.1.251:8890/sparql"} , vBox)
	local input = d.add_component("D#InputField", 	{id = "EndpointInput", text = "http://127.0.0.1:8890/sparql"} , vBox)
	local vboxGraph = d.add_component("D#VerticalBox", 	{horizontalAlignment = -1, verticalAlignment = -1} , vBox)
	--pievienojam labeli, kur aicina ievadit grafu
	d.add_component("D#Label", 	{caption = "Input ontology named graph"} , vboxGraph)
	local inputGraph = d.add_component("D#InputField", 	{id = "namedGraphInput", text = ""} , vboxGraph)
	
	local hBox = d.add_component("D#HorizontalBox", 	{} , vBox)
	local hBox1 = d.add_component("D#HorizontalBox", 	{horizontalAlignment = -1} , hBox)
	local hBox2 = d.add_component("D#HorizontalBox", 	{horizontalAlignment = 1} , hBox)
	local okButton = d.add_component("D#Button", 	{caption = "OK"} , hBox2)
		dialog.add_event_handlers(okButton, {Click = "lua.openProject.spyEndpoint"})
	local listEndpoints = d.add_component("D#Button", 	{caption = "List known endpoints"} , hBox1)
	dialog.add_event_handlers(listEndpoints, {Click = "lua.openProject.endpointList"})

end

function spyEndpoint()
	print ("spy")
	local endpoint
	if lQuery("D#InputField[id = 'EndpointInput']"):is_not_empty() then
		endpoint = lQuery("D#InputField[id = 'EndpointInput']"):attr("text")
		namedGraphName = lQuery("D#InputField[id = 'namedGraphInput']"):attr("text")
	else
		endpoint =  lQuery("D#ListBox[id = 'EndpointList']"):find("/selected"):attr("value")
	end
	lQuery("Onto#Endpoint"):delete()
	local ontoEndpoint = lQuery.create("Onto#Endpoint")
	ontoEndpoint:attr("url", endpoint)
	--lQuery.model.add_property("Onto#Endpoint", "namedGraph")
	ontoEndpoint:attr("namedGraph", namedGraphName)
	onto.onto()
	closeForm()

end

function defaultEndpointForm ()
	--if it is change button then we need to clear the form
	clearForm()

	--add all new elements to form
	local form = lQuery("D#Form[id='".. formID .. "']")

	local vBox = d.add_component("D#VerticalBox", 	{horizontalAlignment = -1} , form)
	local label = d.add_component("D#Label", 	{caption = "Choose from list:"} , vBox)
	local input = d.add_component("D#ListBox", 	{id = "EndpointList"} , vBox)
	local hBox = d.add_component("D#HorizontalBox", 	{} , vBox)
	local hBox1 = d.add_component("D#HorizontalBox", 	{horizontalAlignment = -1} , hBox)
	local hBox2 = d.add_component("D#HorizontalBox", 	{horizontalAlignment = 1} , hBox)
	local okButton = d.add_component("D#Button", 	{caption = "OK"} , hBox2)
	dialog.add_event_handlers(okButton, {Click = "lua.openProject.spyEndpoint"})
	local listEndpoints = d.add_component("D#Button", 	{caption = "Enter endpoint adress"} , hBox1)
	dialog.add_event_handlers(listEndpoints, {Click = "lua.openProject.enterEndpoint"})

	--add enpoint list
	addEndpoints(input)
end

function addEndpoints (listBox)
	local t1 = lQuery.create("D#Item", {value = "http://data.semanticweb.org/sparql"}):link("listBox", listBox)
	t1:link ("parentListBox", listBox)
	lQuery.create("D#Item", {value = "http://data.linkedmdb.org/sparql"}):link("listBox", listBox)
	lQuery.create("D#Item", {value = "http://semantic.eea.europa.eu/sparql"}):link("listBox", listBox)
	lQuery.create("D#Item", {value = "http://education.data.gov.uk/sparql/education/query"}):link("listBox", listBox)
	lQuery.create("D#Item", {value = "http://transport.data.gov.uk/sparql/transport/query"}):link("listBox", listBox)
	lQuery.create("D#Item", {value = "http://reference.data.gov.uk/sparql/reference/query"}):link("listBox", listBox)
	--lQuery.create("D#Item", {value = "http://api.talis.com/stores/ordnance-survey/services/sparql"}):link("listBox", listBox)
	--lQuery.create("D#Item", {value = ""}):link("listBox", listBox)
end

--creates a form where is it possible to enter an endpoint
function enterEndpoint ()
	endpointForm()
	dialog.refresh_form_component(lQuery("D#Form[id='".. formID .. "']"))

end

--form that contains default endpoint list to where one can connect
function endpointList ()
	defaultEndpointForm()
	dialog.refresh_form_component(lQuery("D#Form[id='".. formID .. "']"))

end

--clear the form from all the elements
function clearForm()
	local form = lQuery("D#Form[id='".. formID .. "']")
	local components = form:transitive_closure("/component"):remove(form)
	components:delete()
end


function closeForm ()
	--form = lQuery("D#Form[id='ConnectEndpoint']"):link("command", function() return utilities.execute_cmd("D#Command", {info = "Close"}) end)
--	local endpoint
--	if lQuery("D#InputField[id = 'EndpointInput']"):is_not_empty() then
--		endpoint = lQuery("D#InputField[id = 'EndpointInput']"):attr("text")
--	else
--		endpoint =  lQuery("D#ListBox[id = 'EndpointList']"):find("/selected"):attr("value")
--	end
--	lQuery("Onto#Endpoint"):delete()
--	local ontoEndpoint = lQuery.create("Onto#Endpoint")
--	ontoEndpoint:attr("url", endpoint)
--	onto.onto()
	dialog.close_form(formID)
	--
end

function close()
	dialog.close_form(formID)
end

--[[
function spyEndpoint()
	spy.delete_onto()
	input = lQuery("D#Component[id = 'EndpointInput']")
	local endpoint = input:attr("text")
	spy.spy_endpoint("http://194.8.1.251:8890/sparql")
	recalc.associations()
end
--]]
